#if CH_LANG_CC
/* _______              __
  / ___/ /  ___  __ _  / /  ___
 / /__/ _ \/ _ \/  ' \/ _ \/ _ \
 \___/_//_/\___/_/_/_/_.__/\___/
*/
//
// This software is copyright (C) by the Lawrence Berkeley
// National Laboratory.  Permission is granted to reproduce
// this software for non-commercial purposes provided that
// this notice is left intact.
//
// It is acknowledged that the U.S. Government has rights to
// this software under Contract DE-AC03-765F00098 between
// the U.S.  Department of Energy and the University of
// California.
//
// This software is provided as a professional and academic
// contribution for joint exchange. Thus it is experimental,
// is provided ``as is'', with no warranties of any kind
// whatsoever, no support, no promise of updates, or printed
// documentation. By using this software, you acknowledge
// that the Lawrence Berkeley National Laboratory and
// Regents of the University of California shall have no
// liability with respect to the infringement of other
// copyrights by any part of this software.
//

// Constants used between C++ and Fortran to index the conserved and
// primitive variables and to know the number of each.  Also, the number
// of slopes and fluxes are defined here.
#endif

#ifndef CH_LGINTEGRATOR_H
#define CH_LGINTEGRATOR_H

#if (CH_SPACEDIM == 2)

#define QRHO   0
#define QVELX  1
#define QVELY  2
#define QPRES  3
#define QNUM   4
#define QSLOPE 4

#define CRHO  0
#define CMOMX 1
#define CMOMY 2
#define CENG  3
#define CNUM  4
#define CFLUX 4

#define MWAVE 0
#define ZWAVE 1
#define PWAVE 3
#endif

#if (CH_SPACEDIM == 3)

#define QRHO   0
#define QVELX  1
#define QVELY  2
#define QVELZ  3
#define QPRES  4
#define QNUM   5
#define QSLOPE 5

#define CRHO  0
#define CMOMX 1
#define CMOMY 2
#define CMOMZ 3
#define CENG  4

#define CNUM  5

#define MWAVE 0
#define ZWAVE 1
#define PWAVE 4
#endif

#endif
